	; --------------------------
	; YZIP
	; Z-CODE INTERPRETER PROGRAM
	; FOR APPLE ][e/][c/][gs
	; --------------------------

	; INFOCOM, INC.
	; 125 CAMBRIDGEPARK DRIVE
	; CAMBRIDGE, MA 02140

	; COMPANY PRIVATE -- NOT FOR DISTRIBUTION

	PL	50000		; PAGE LENGTH OF PRINTER

DEBUG	EQU	0	; ASSEMBLY FLAG FOR DEBUGGER (1 = YES)
CHECKSUM EQU 	0	; == 1 for generating save/restore checksum

 	; -----------
	; ERROR CODES
	; -----------

	; 00 -- INSUFFICIENT RAM
	; 01 -- ILLEGAL X-OP
	; 02 -- ILLEGAL 0-OP
	; 03 -- ILLEGAL 1-OP
	; 04 -- ILLEGAL 2-OP
	; 05 -- Z-STACK UNDERFLOW
	; 06 -- Z-STACK OVERFLOW
	; 07 -- ILLEGAL PROPERTY LENGTH (GETP)
	; 08 -- DIVISION BY ZERO
	; 09 -- ILLEGAL ARGUMENT COUNT (EQUAL?)
	; 10 -- ILLEGAL PROPERTY ID (PUTP)
	; 11 -- ILLEGAL PROPERTY LENGTH (PUTP)
	; 12 -- DISK ADDRESS OUT OF RANGE
	; 13 -- IMPURE CODE TOO LARGE (BM 1/20/86)
	; 14 -- DRIVE ACCESS
	; 15 -- NOT AN EZIP GAME
	; 16 -- ILLEGAL EXTENDED RANGE X-OP
	; 17 -- BAD VIRTUAL PAGE
	; 18 -- SETPC NOT PRELOADED
	; 19 -- PREVIOUS (SPC/FPC) NOT POSSIBLE
	; 20 -- PICTURE NOT FOUND
        ; 21 -- ZERO OBJECT TO BE REMOVED
	; 22 -- OBJECT TOO BIG (ZLOC)
	; 23 -- Bad read: Read != Asked for
	; 24 -- Bad read: Retry 1 != Retry 2
	; 25 -- Clear of zero height/width window
	
	TITLE	"APPLE YZIP (c)Infocom, Inc. --- EQUATES AND SUCH"
	INCLUDE 	ZIP.EQU
	INCLUDE		ZERO.EQU
	INCLUDE		PRODOS.EQU
	INCLUDE 	APPLE.EQU
	INCLUDE		MACROS.ASM

	TITLE 	"APPLE YZIP (c)Infocom, Inc.. --- INIT & MAINLINE"
	INCLUDE		ZBEGIN.ASM
	INCLUDE 	MAIN.ASM
	INCLUDE 	SUBS.ASM
	INCLUDE 	DISPATCH.ASM

	TITLE 	"APPLE YZIP (c)Infocom, Inc.. --- MACHINE DEPENDENT SHELL"
	INCLUDE		ZDOS.ASM
	INCLUDE		MACHINE.ASM
	INCLUDE		IO.ASM	
	INCLUDE		VERIFY.ASM
	INCLUDE		SCREEN.ASM
	INCLUDE		TABLES.ASM
	INCLUDE		WINDOWS.ASM
	INCLUDE		DLINE.ASM
	INCLUDE		PIC.ASM

	TITLE 	"APPLE YZIP (c)Infocom, Inc.. --- OPCODE EXECUTORS"
	INCLUDE 	OPS012.ASM
	INCLUDE 	OPSX.ASM
	INCLUDE 	READ.ASM
	INCLUDE		ZSAVRES.ASM

	TITLE 	"APPLE YZIP (c)Infocom, Inc.. --- OP SUPPORT & MEMORY MANAGEMENT"
	INCLUDE 	XPAGING.ASM
	INCLUDE 	ZSTRING.ASM
	INCLUDE 	OBJECTS.ASM

	BLKB	ZBEGIN-$,0
	END

